Lorene::Et_rot_diff Class Reference
Stars and black holes

Class for differentially rotating stars. More...

`#include <et_rot_diff.h>`

Inheritance diagram for Lorene::Et_rot_diff:

## Public Member Functions

| Et_rot_diff (Map &mp_i, int nzet_i, bool relat, const Eos &eos_i, double(*frot_i)(double, const Tbl &), double(*primfrot_i)(double, const Tbl &), const Tbl &par_frot_i)
| Standard constructor.
| Et_rot_diff (const Et_rot_diff &)
| Copy constructor.
| Et_rot_diff (Map &mp_i, const Eos &eos_i, FILE *fich, double(*frot_i)(double, const Tbl &), double(*primfrot_i)(double, const Tbl &))
| Constructor from a file (see `sauve(FILE*)` ).
virtual | ~Et_rot_diff ()
| Destructor.
void | operator= (const Et_rot_diff &)
| Assignment to another `Et_rot_diff`.
const Tenseur & | get_omega_field () const
| Returns the angular velocity field .
virtual double | get_omega_c () const
| Returns the central value of the rotation angular velocity (``[f_unit] ).
virtual void | sauve (FILE *) const
| Save in a file.
virtual void | display_poly (ostream &) const
| Display in polytropic units.
virtual double | tsw () const
| Ratio T/W.
virtual void | hydro_euler ()
| Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame.
void | fait_omega_field (double omeg_min, double omeg_max, double precis, int nitermax)
| Computes (member `omega_field` ).
void | fait_prim_field ()
| Computes the member `prim_field` from `omga_field` .
double | funct_omega (double omeg) const
| Evaluates , where F is the function defining the rotation profile.
double | prim_funct_omega (double omeg) const
| Evaluates the primitive of , where F is the function defining the rotation profile.
virtual void | equilibrium (double ent_c, double omega0, double fact_omega, int nzadapt, const Tbl &ent_limit, const Itbl &icontrol, const Tbl &control, double mbar_wanted, double aexp_mass, Tbl &diff, Param *=0x0)
| Computes an equilibrium configuration.
const Tenseur & | get_bbb () const
| Returns the metric factor B.
const Tenseur & | get_b_car () const
| Returns the square of the metric factor B.
const Tenseur & | get_nphi () const
| Returns the metric coefficient .
const Tenseur & | get_tnphi () const
| Returns the component of the shift vector.
const Tenseur & | get_uuu () const
| Returns the norm of `u_euler`.
const Tenseur & | get_logn () const
| Returns the metric potential = `logn_auto`.
const Tenseur & | get_nuf () const
| Returns the part of the Metric potential = `logn` generated by the matter terms.
const Tenseur & | get_nuq () const
| Returns the Part of the Metric potential = `logn` generated by the quadratic terms.
const Tenseur & | get_dzeta () const
| Returns the Metric potential = `beta_auto`.
const Tenseur & | get_tggg () const
| Returns the Metric potential .
const Tenseur & | get_w_shift () const
| Returns the vector used in the decomposition of `shift` , following Shibata's prescription [Prog.
const Tenseur & | get_khi_shift () const
| Returns the scalar used in the decomposition of `shift` following Shibata's prescription [Prog.
const Tenseur_sym & | get_tkij () const
| Returns the tensor related to the extrinsic curvature tensor by .
const Tenseur & | get_ak_car () const
| Returns the scalar .
virtual const Itbl & | l_surf () const
| Description of the stellar surface: returns a 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .
virtual double | mass_b () const
| Baryon mass.
virtual double | mass_g () const
| Gravitational mass.
virtual double | angu_mom () const
| Angular momentum.
virtual double | grv2 () const
| Error on the virial identity GRV2.
virtual double | grv3 (ostream *ost=0x0) const
| Error on the virial identity GRV3.
virtual double | r_circ () const
| Circumferential radius.
virtual double | area () const
| Surface area.
virtual double | mean_radius () const
| Mean radius.
virtual double | aplat () const
| Flatening r_pole/r_eq.
virtual double | z_eqf () const
| Forward redshift factor at equator.
virtual double | z_eqb () const
| Backward redshift factor at equator.
virtual double | z_pole () const
| Redshift factor at North pole.
virtual double | mom_quad () const
| Quadrupole moment.
virtual double | mom_quad_old () const
| Part of the quadrupole moment.
virtual double | mom_quad_Bo () const
| Part of the quadrupole moment.
virtual double | r_isco (ostream *ost=0x0) const
| Circumferential radius of the innermost stable circular orbit (ISCO).
virtual double | f_isco () const
| Orbital frequency at the innermost stable circular orbit (ISCO).
virtual double | espec_isco () const
| Energy of a particle on the ISCO.
virtual double | lspec_isco () const
| Angular momentum of a particle on the ISCO.
virtual double | f_eccentric (double ecc, double periast, ostream *ost=0x0) const
| Computation of frequency of eccentric orbits.
virtual double | f_eq () const
| Orbital frequency at the equator.
void | update_metric ()
| Computes metric coefficients from known potentials.
void | fait_shift ()
| Computes `shift` from `w_shift` and `khi_shift` according to Shibata's prescription [Prog.
void | fait_nphi ()
| Computes `tnphi` and `nphi` from the Cartesian components of the shift, stored in `shift` .
void | extrinsic_curvature ()
| Computes `tkij` and `ak_car` from `shift` , `nnn` and `b_car` .
Map & | set_mp ()
| Read/write of the mapping.
void | set_enthalpy (const Cmp &)
| Assignment of the enthalpy field.
virtual void | equation_of_state ()
| Computes the proper baryon and energy density, as well as pressure from the enthalpy.
virtual void | equilibrium_spher (double ent_c, double precis=1.e-14, const Tbl *ent_limit=0x0)
| Computes a spherical static configuration.
void | equil_spher_regular (double ent_c, double precis=1.e-14)
| Computes a spherical static configuration.
virtual void | equil_spher_falloff (double ent_c, double precis=1.e-14)
| Computes a spherical static configuration with the outer boundary condition at a finite radius.
const Map & | get_mp () const
| Returns the mapping.
int | get_nzet () const
| Returns the number of domains occupied by the star.
bool | is_relativistic () const
| Returns `true` for a relativistic star, `false` for a Newtonian one.
const Eos & | get_eos () const
| Returns the equation of state.
const Tenseur & | get_ent () const
| Returns the enthalpy field.
const Tenseur & | get_nbar () const
| Returns the proper baryon density.
const Tenseur & | get_ener () const
| Returns the proper total energy density.
const Tenseur & | get_press () const
| Returns the fluid pressure.
const Tenseur & | get_ener_euler () const
| Returns the total energy density with respect to the Eulerian observer.
const Tenseur & | get_s_euler () const
| Returns the trace of the stress tensor in the Eulerian frame.
const Tenseur & | get_gam_euler () const
| Returns the Lorentz factor between the fluid and Eulerian observers.
const Tenseur & | get_u_euler () const
| Returns the fluid 3-velocity with respect to the Eulerian observer.
const Tenseur & | get_logn_auto () const
| Returns the logarithm of the part of the lapse N generated principaly by the star.
const Tenseur & | get_logn_auto_regu () const
| Returns the regular part of the logarithm of the part of the lapse N generated principaly by the star.
const Tenseur & | get_logn_auto_div () const
| Returns the divergent part of the logarithm of the part of the lapse N generated principaly by the star.
const Tenseur & | get_d_logn_auto_div () const
| Returns the gradient of `logn_auto_div`.
const Tenseur & | get_beta_auto () const
| Returns the logarithm of the part of the product AN generated principaly by the star.
const Tenseur & | get_nnn () const
| Returns the total lapse function N.
const Tenseur & | get_shift () const
| Returns the total shift vector .
const Tenseur & | get_a_car () const
| Returns the total conformal factor .
double | ray_eq () const
| Coordinate radius at , [r_unit].
double | ray_eq (int kk) const
| Coordinate radius at , [r_unit].
double | ray_eq_pis2 () const
| Coordinate radius at , [r_unit].
double | ray_eq_pi () const
| Coordinate radius at , [r_unit].
double | ray_eq_3pis2 () const
| Coordinate radius at , [r_unit].
double | ray_pole () const
| Coordinate radius at [r_unit].
const Tbl & | xi_surf () const
| Description of the stellar surface: returns a 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

## Static Public Member Functions

static double | lambda_grv2 (const Cmp &sou_m, const Cmp &sou_q)
| Computes the coefficient which ensures that the GRV2 virial identity is satisfied.

## Protected Member Functions

virtual ostream & | operator>> (ostream &) const
| Operator >> (virtual function called by the operator <<).
virtual void | del_deriv () const
| Deletes all the derived quantities.
virtual void | set_der_0x0 () const
| Sets to `0x0` all the pointers on derived quantities.
virtual void | del_hydro_euler ()
| Sets to `ETATNONDEF` (undefined state) the hydrodynamical quantities relative to the Eulerian observer.
virtual void | partial_display (ostream &) const
| Printing of some informations, excluding all global quantities.

## Protected Attributes

double(* | frot )(double, const Tbl &)
| Function defining the rotation profile.
double(* | primfrot )(double, const Tbl &)
| Primitive of the function , which vanishes at the stellar center.
Tbl | par_frot
| Parameters of the function .
Tenseur | omega_field
| Field .
double | omega_min
| Minimum value of .
double | omega_max
| Maximum value of .
Tenseur | prim_field
| Field .
double | omega
| Rotation angular velocity (``[f_unit] ).
Tenseur | bbb
| Metric factor B.
Tenseur | b_car
| Square of the metric factor B.
Tenseur | nphi
| Metric coefficient .
Tenseur | tnphi
| Component of the shift vector.
Tenseur | uuu
| Norm of `u_euler`.
Tenseur & | logn
| Metric potential = `logn_auto`.
Tenseur | nuf
| Part of the Metric potential = `logn` generated by the matter terms.
Tenseur | nuq
| Part of the Metric potential = `logn` generated by the quadratic terms.
Tenseur & | dzeta
| Metric potential = `beta_auto`.
Tenseur | tggg
| Metric potential .
Tenseur | w_shift
| Vector used in the decomposition of `shift` , following Shibata's prescription [Prog.
Tenseur | khi_shift
| Scalar used in the decomposition of `shift` , following Shibata's prescription [Prog.
Tenseur_sym | tkij
| Tensor related to the extrinsic curvature tensor by .
Tenseur | ak_car
| Scalar .
Cmp | ssjm1_nuf
| Effective source at the previous step for the resolution of the Poisson equation for `nuf` by means of `Map_et::poisson` .
Cmp | ssjm1_nuq
| Effective source at the previous step for the resolution of the Poisson equation for `nuq` by means of `Map_et::poisson` .
Cmp | ssjm1_dzeta
| Effective source at the previous step for the resolution of the Poisson equation for `dzeta` .
Cmp | ssjm1_tggg
| Effective source at the previous step for the resolution of the Poisson equation for `tggg` .
Cmp | ssjm1_khi
| Effective source at the previous step for the resolution of the Poisson equation for the scalar by means of `Map_et::poisson` .
Tenseur | ssjm1_wshift
| Effective source at the previous step for the resolution of the vector Poisson equation for .
double * | p_angu_mom
| Angular momentum.
double * | p_tsw
| Ratio T/W.
double * | p_grv2
| Error on the virial identity GRV2.
double * | p_grv3
| Error on the virial identity GRV3.
double * | p_r_circ
| Circumferential radius.
double * | p_area
| Surface area.
double * | p_aplat
| Flatening r_pole/r_eq.
double * | p_z_eqf
| Forward redshift factor at equator.
double * | p_z_eqb
| Backward redshift factor at equator.
double * | p_z_pole
| Redshift factor at North pole.
double * | p_mom_quad
| Quadrupole moment.
double * | p_mom_quad_old
| Part of the quadrupole moment.
double * | p_mom_quad_Bo
| Part of the quadrupole moment.
double * | p_r_isco
| Circumferential radius of the ISCO.
double * | p_f_isco
| Orbital frequency of the ISCO.
double * | p_espec_isco
| Specific energy of a particle on the ISCO.
double * | p_lspec_isco
| Specific angular momentum of a particle on the ISCO.
double * | p_f_eq
| Orbital frequency at the equator.
Map & | mp
| Mapping associated with the star.
int | nzet
| Number of domains of `*mp` occupied by the star.
bool | relativistic
| Indicator of relativity: `true` for a relativistic star, `false` for a Newtonian one.
double | unsurc2
| : `unsurc2=1` for a relativistic star, 0 for a Newtonian one.
int | k_div
| Index of regularity of the gravitational potential `logn_auto` .
const Eos & | eos
| Equation of state of the stellar matter.
Tenseur | ent
| Log-enthalpy (relativistic case) or specific enthalpy (Newtonian case).
Tenseur | nbar
| Baryon density in the fluid frame.
Tenseur | ener
| Total energy density in the fluid frame.
Tenseur | press
| Fluid pressure.
Tenseur | ener_euler
| Total energy density in the Eulerian frame.
Tenseur | s_euler
| Trace of the stress tensor in the Eulerian frame.
Tenseur | gam_euler
| Lorentz factor between the fluid and Eulerian observers.
Tenseur | u_euler
| Fluid 3-velocity with respect to the Eulerian observer.
Tenseur | logn_auto
| Total of the logarithm of the part of the lapse N generated principaly by the star.
Tenseur | logn_auto_regu
| Regular part of the logarithm of the part of the lapse N generated principaly by the star.
Tenseur | logn_auto_div
| Divergent part (if `k_div!=0` ) of the logarithm of the part of the lapse N generated principaly by the star.
Tenseur | d_logn_auto_div
| Gradient of `logn_auto_div` (if `k_div!=0` ).
Tenseur | beta_auto
| Logarithm of the part of the product AN generated principaly by by the star.
Tenseur | nnn
| Total lapse function.
Tenseur | shift
| Total shift vector.
Tenseur | a_car
| Total conformal factor .
double * | p_ray_eq
| Coordinate radius at , .
double * | p_ray_eq_pis2
| Coordinate radius at , .
double * | p_ray_eq_pi
| Coordinate radius at , .
double * | p_ray_eq_3pis2
| Coordinate radius at , .
double * | p_ray_pole
| Coordinate radius at .
Itbl * | p_l_surf
| Description of the stellar surface: 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .
Tbl * | p_xi_surf
| Description of the stellar surface: 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .
double * | p_mass_b
| Baryon mass.
double * | p_mass_g
| Gravitational mass.

## Detailed Description

Class for differentially rotating stars.

()

Definition at line 70 of file et_rot_diff.h.

## Constructor & Destructor Documentation

## Et_rot_diff() [1/3]

Lorene::Et_rot_diff::Et_rot_diff | ( | Map & | mp_i,
|  | int | nzet_i,
|  | bool | relat,
|  | const Eos & | eos_i,
|  | double(* | frot_i )(double, const Tbl &),
|  | double(* | primfrot_i )(double, const Tbl &),
|  | const Tbl & | par_frot_i )

Standard constructor.

Parameters

  mp_i | Mapping on which the star will be defined
  nzet_i | Number of domains occupied by the star
  relat | should be `true` for a relativistic star, `false` for a Newtonian one
  eos_i | Equation of state of the stellar matter
  frot_i | Function defining the rotation profile.
  primfrot_i | Primitive of which vanishes at the stellar center
  par_frot_i | Parameters of functions `frot_i` and `primfrot_i` , `par_frot_i(0)` being the central value of .

Definition at line 82 of file et_rot_diff.C.

References Lorene::Etoile_rot::Etoile_rot(), frot, Lorene::Map(), Lorene::Etoile_rot::omega, omega_field, omega_max, omega_min, par_frot, prim_field, and primfrot.

## Et_rot_diff() [2/3]

Lorene::Et_rot_diff::Et_rot_diff | ( | const Et_rot_diff & | et | ) |

Copy constructor.

Definition at line 107 of file et_rot_diff.C.

References Et_rot_diff(), Lorene::Etoile_rot::Etoile_rot(), frot, omega_field, omega_max, omega_min, par_frot, prim_field, and primfrot.

## Et_rot_diff() [3/3]

Lorene::Et_rot_diff::Et_rot_diff | ( | Map & | mp_i,
|  | const Eos & | eos_i,
|  | FILE * | fich,
|  | double(* | frot_i )(double, const Tbl &),
|  | double(* | primfrot_i )(double, const Tbl &) )

Constructor from a file (see `sauve(FILE*)` ).

Parameters

  mp_i | Mapping on which the star will be defined
  eos_i | Equation of state of the stellar matter
  fich | input file (must have been created by the function `sauve` )
  frot_i | Function defining the rotation profile.
  primfrot_i | Primitive of which vanishes at the stellar center

Definition at line 121 of file et_rot_diff.C.

References Lorene::Etoile_rot::Etoile_rot(), fait_prim_field(), Lorene::fread_be(), frot, Lorene::Map(), Lorene::Etoile::mp, omega_field, omega_max, omega_min, par_frot, prim_field, and primfrot.

## ~Et_rot_diff()

Lorene::Et_rot_diff::~Et_rot_diff | ( |  | ) |

virtual

Destructor.

Definition at line 147 of file et_rot_diff.C.

## Member Function Documentation

## angu_mom()

double Lorene::Etoile_rot::angu_mom | ( |  | ) | const

virtual inherited

Angular momentum.

Reimplemented in Lorene::Et_magnetisation, Lorene::Et_rot_bifluid, and Lorene::Et_rot_mag.

Definition at line 188 of file et_rot_global.C.

References Lorene::Etoile::a_car, b_car, Lorene::Etoile::ener_euler, Lorene::Cmp::integrale(), Lorene::Cmp::mult_r(), Lorene::Etoile::nbar, p_angu_mom, Lorene::Etoile::press, Lorene::Etoile::relativistic, Lorene::Cmp::std_base_scal(), uuu, and Lorene::Cmp::va.

## aplat()

double Lorene::Etoile_rot::aplat | ( |  | ) | const

virtual inherited

Flatening r_pole/r_eq.

Definition at line 496 of file et_rot_global.C.

References p_aplat, Lorene::Etoile::ray_eq(), and Lorene::Etoile::ray_pole().

## area()

double Lorene::Etoile_rot::area | ( |  | ) | const

virtual inherited

Surface area.

Definition at line 420 of file et_rot_global.C.

References Lorene::Valeur::annule_hard(), Lorene::Valeur::c_cf, Lorene::Valeur::dsdt(), Lorene::Etoile::get_a_car(), Lorene::Mg3d::get_angu(), get_bbb(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), l_surf(), Lorene::Etoile::mp, Lorene::Valeur::mult_st(), p_area, Lorene::Valeur::set(), Lorene::sqrt(), Lorene::Valeur::std_base_scal(), Lorene::Cmp::va, Lorene::Valeur::val_point_jk(), Lorene::Map_radial::val_r_jk(), and Lorene::Etoile::xi_surf().

## del_deriv()

void Lorene::Etoile_rot::del_deriv | ( |  | ) | const

protected virtual inherited

Deletes all the derived quantities.

Reimplemented from Lorene::Etoile.

Reimplemented in Lorene::Et_rot_bifluid, and Lorene::Et_rot_mag.

Definition at line 335 of file etoile_rot.C.

References Lorene::Etoile::del_deriv(), p_angu_mom, p_aplat, p_area, p_espec_isco, p_f_eq, p_f_isco, p_grv2, p_grv3, p_lspec_isco, p_mom_quad, p_mom_quad_Bo, p_mom_quad_old, p_r_circ, p_r_isco, p_tsw, p_z_eqb, p_z_eqf, p_z_pole, and set_der_0x0().

## del_hydro_euler()

void Lorene::Etoile_rot::del_hydro_euler | ( |  | ) |

protected virtual inherited

Sets to `ETATNONDEF` (undefined state) the hydrodynamical quantities relative to the Eulerian observer.

Reimplemented from Lorene::Etoile.

Reimplemented in Lorene::Et_rot_bifluid, and Lorene::Et_rot_mag.

Definition at line 389 of file etoile_rot.C.

References del_deriv(), and Lorene::Etoile::del_hydro_euler().

## display_poly()

void Lorene::Et_rot_diff::display_poly | ( | ostream & | ost | ) | const

virtual

Display in polytropic units.

Reimplemented from Lorene::Etoile_rot.

Definition at line 268 of file et_rot_diff.C.

References Lorene::Etoile_rot::display_poly(), Lorene::Etoile::ener, Lorene::Etoile::eos, Lorene::Eos_poly::get_gam(), Lorene::Eos_poly::get_kap(), Lorene::max(), Lorene::Etoile::mp, Lorene::Etoile::nbar, Lorene::Etoile::nzet, omega_field, omega_max, omega_min, Lorene::pow(), and Lorene::sqrt().

## equation_of_state()

void Lorene::Etoile::equation_of_state | ( |  | ) |

virtual inherited

Computes the proper baryon and energy density, as well as pressure from the enthalpy.

Reimplemented in Lorene::Et_magnetisation, and Lorene::Et_rot_bifluid.

Definition at line 566 of file etoile.C.

References Lorene::Param::add_int(), Lorene::Cmp::allocate_all(), del_deriv(), ener, ent, eos, Lorene::Mg3d::get_grille3d(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), mp, nbar, nzet, press, Lorene::Cmp::set(), Lorene::Mtbl::set(), Lorene::Mtbl::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Cmp::std_base_scal(), Lorene::Mtbl::t, and Lorene::Grille3d::x.

## equil_spher_falloff()

void Lorene::Etoile::equil_spher_falloff | ( | double | ent_c,
|  | double | precis = 1.e-14 )

virtual inherited

Computes a spherical static configuration with the outer boundary condition at a finite radius.

Parameters

  ent_c | [input] central value of the enthalpy
  precis | [input] threshold in the relative difference between the enthalpy fields of two consecutive steps to stop the iterative procedure (default value: 1.e-14)

Definition at line 57 of file etoile_eqsph_falloff.C.

References a_car, beta_auto, Lorene::diffrel(), Lorene::Cmp::dsdr(), Lorene::Map_af::dsdr(), ener, ener_euler, ent, equation_of_state(), Lorene::exp(), gam_euler, Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Map_af::homothetie(), logn_auto, mass_b(), mass_g(), mp, nbar, nnn, Lorene::norme(), nzet, press, relativistic, s_euler, Lorene::Tenseur::set(), Lorene::Tenseur::set_etat_qcq(), Lorene::Tenseur::set_std_base(), shift, Lorene::sqrt(), u_euler, and unsurc2.

## equil_spher_regular()

void Lorene::Etoile::equil_spher_regular | ( | double | ent_c,
|  | double | precis = 1.e-14 )

inherited

Computes a spherical static configuration.

The sources for Poisson equations are regularized by extracting analytical diverging parts.

Parameters

  ent_c | [input] central value of the enthalpy
  precis | [input] threshold in the relative difference between the enthalpy fields of two consecutive steps to stop the iterative procedure (default value: 1.e-14)

Definition at line 115 of file et_equil_spher_regu.C.

References a_car, beta_auto, d_logn_auto_div, Lorene::diffrel(), Lorene::Map_af::dsdr(), ener, ener_euler, ent, eos, equation_of_state(), Lorene::exp(), gam_euler, Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Map_af::homothetie(), k_div, logn_auto, logn_auto_div, logn_auto_regu, mass_b(), mass_g(), mp, nbar, nnn, Lorene::norme(), nzet, Lorene::Map_af::poisson(), Lorene::Map_af::poisson_regular(), press, relativistic, s_euler, Lorene::Tenseur::set(), Lorene::Tenseur::set_etat_qcq(), Lorene::Tenseur::set_std_base(), shift, Lorene::sqrt(), Lorene::Cmp::std_base_scal(), u_euler, and unsurc2.

## equilibrium()

void Lorene::Et_rot_diff::equilibrium | ( | double | ent_c,
|  | double | omega0,
|  | double | fact_omega,
|  | int | nzadapt,
|  | const Tbl & | ent_limit,
|  | const Itbl & | icontrol,
|  | const Tbl & | control,
|  | double | mbar_wanted,
|  | double | aexp_mass,
|  | Tbl & | diff,
|  | Param * | = 0x0 )

virtual

Computes an equilibrium configuration.

Parameters

  ent_c | [input] Central enthalpy
  omega0 | [input] Requested central angular velocity (if `fact_omega=1`. )

  fact_omega

  [input] 1.01 = search for the Keplerian frequency,
  1. = otherwise.

  nzadapt | [input] Number of (inner) domains where the mapping adaptation to an iso-enthalpy surface should be performed
  ent_limit | [input] 1-D `Tbl` of dimension `nzet` which defines the enthalpy at the outer boundary of each domain

  icontrol

  [input] Set of integer parameters (stored as a 1-D `Itbl` of size 8) to control the iteration:
  - `icontrol(0)` = mer_max : maximum number of steps
  - `icontrol(1)` = mer_rot : step at which the rotation is switched on
  - `icontrol(2)` = mer_change_omega : step at which the rotation velocity is changed to reach the final one
  - `icontrol(3)` = mer_fix_omega : step at which the final rotation velocity must have been reached
  - `icontrol(4)` = mer_mass : the absolute value of `mer_mass` is the step from which the baryon mass is forced to converge, by varying the central enthalpy (`mer_mass` > 0 ) or the angular velocity (`mer_mass` < 0 )
  - `icontrol(5)` = mermax_poisson : maximum number of steps in `Map_et::poisson`
  - `icontrol(6)` = mer_triax : step at which the 3-D perturbation is switched on
  - `icontrol(7)` = delta_mer_kep : number of steps after `mer_fix_omega` when `omega` starts to be increased by `fact_omega` to search for the Keplerian velocity

  control

  [input] Set of parameters (stored as a 1-D `Tbl` of size 7) to control the iteration:
  - `control(0)` = precis : threshold on the enthalpy relative change for ending the computation
  - `control(1)` = omega_ini : initial central angular velocity, switched on only if `mer_rot` < 0 , otherwise 0 is used
  - `control(2)` = relax : relaxation factor in the main iteration
  - `control(3)` = relax_poisson : relaxation factor in `Map_et::poisson`
  - `control(4)` = thres_adapt : threshold on dH/dr for freezing the adaptation of the mapping
  - `control(5)` = ampli_triax : relative amplitude of the 3-D perturbation
  - `control(6)` = precis_adapt : precision for `Map_et::adapt`

  mbar_wanted | [input] Requested baryon mass (effective only if `mer_mass` > mer_max )
  aexp_mass | [input] Exponent for the increase factor of the central enthalpy to converge to the requested baryon mass

  diff

  [output] 1-D `Tbl` of size 7 for the storage of some error indicators :
  - `diff(0)` : Relative change in the enthalpy field between two successive steps
  - `diff(1)` : Relative error in the resolution of the Poisson equation for `nuf`
  - `diff(2)` : Relative error in the resolution of the Poisson equation for `nuq`
  - `diff(3)` : Relative error in the resolution of the Poisson equation for `dzeta`
  - `diff(4)` : Relative error in the resolution of the Poisson equation for `tggg`
  - `diff(5)` : Relative error in the resolution of the equation for `shift` (x comp.)
  - `diff(6)` : Relative error in the resolution of the equation for `shift` (y comp.)

Reimplemented from Lorene::Etoile_rot.

Definition at line 88 of file et_rot_diff_equil.C.

References Lorene::Etoile::a_car, Lorene::abs(), Lorene::Param::add_cmp_mod(), Lorene::Param::add_double(), Lorene::Param::add_double_mod(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Param::add_tbl(), Lorene::Param::add_tenseur_mod(), Lorene::Etoile_rot::ak_car, Lorene::Cmp::annule(), Lorene::Etoile_rot::bbb, Lorene::Valeur::c_cf, Lorene::Tenseur::change_triad(), Lorene::Valeur::coef(), Lorene::cos(), Lorene::diffrel(), Lorene::Etoile_rot::dzeta, Lorene::Etoile::ener_euler, Lorene::Etoile::ent, Lorene::Etoile::equation_of_state(), Lorene::Etoile_rot::fait_nphi(), fait_omega_field(), Lorene::flat_scalar_prod(), Lorene::Etoile::gam_euler, Lorene::Tenseur::get_etat(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Mg3d::get_type_t(), Lorene::Tenseur::gradient_spher(), Lorene::Etoile_rot::grv2(), Lorene::Map_et::homothetie(), hydro_euler(), Lorene::Etoile_rot::khi_shift, Lorene::log(), Lorene::log10(), Lorene::Etoile_rot::logn, Lorene::Etoile_rot::mass_b(), Lorene::Etoile_rot::mass_g(), Lorene::Etoile::mp, Lorene::Cmp::mult_rsint(), Lorene::Etoile::nbar, Lorene::Etoile::nnn, Lorene::Etoile_rot::nphi, Lorene::Etoile_rot::nuf, Lorene::Etoile_rot::nuq, Lorene::Etoile::nzet, Lorene::Etoile_rot::omega, omega_field, par_frot, Lorene::Etoile_rot::partial_display(), Lorene::phi, Lorene::Tenseur::poisson_vect(), Lorene::pow(), Lorene::Etoile::press, prim_field, Lorene::Etoile::ray_eq(), Lorene::Etoile::ray_pole(), Lorene::Etoile::relativistic, Lorene::Etoile::s_euler, Lorene::Tbl::set(), Lorene::Tenseur::set(), Lorene::Tbl::set_etat_qcq(), Lorene::Tenseur::set_std_base(), Lorene::Etoile::shift, Lorene::sint, Lorene::sqrt(), Lorene::Etoile_rot::ssjm1_khi, Lorene::Etoile_rot::ssjm1_nuf, Lorene::Etoile_rot::ssjm1_nuq, Lorene::Etoile_rot::ssjm1_tggg, Lorene::Etoile_rot::ssjm1_wshift, Lorene::Cmp::std_base_scal(), Lorene::Etoile_rot::tggg, Lorene::Etoile_rot::tkij, Lorene::Etoile::u_euler, Lorene::Etoile_rot::update_metric(), Lorene::Etoile_rot::uuu, Lorene::Cmp::va, and Lorene::Etoile_rot::w_shift.

## equilibrium_spher()

void Lorene::Etoile::equilibrium_spher | ( | double | ent_c,
|  | double | precis = 1.e-14,
|  | const Tbl * | ent_limit = 0x0 )

virtual inherited

Computes a spherical static configuration.

Parameters

  ent_c | [input] central value of the enthalpy
  precis | [input] threshold in the relative difference between the enthalpy fields of two consecutive steps to stop the iterative procedure (default value: 1.e-14)
  ent_limit | [input] : array of enthalpy values to be set at the boundaries between the domains; if set to 0x0 (default), the initial values will be kept.

Definition at line 87 of file etoile_equil_spher.C.

References a_car, Lorene::Map_et::adapt(), Lorene::Param::add_double(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Param::add_tbl(), beta_auto, Lorene::diffrel(), Lorene::Cmp::dsdr(), Lorene::Map_af::dsdr(), ener, ener_euler, ent, equation_of_state(), Lorene::exp(), gam_euler, Lorene::Map_af::get_alpha(), Lorene::Map_et::get_alpha(), Lorene::Map_af::get_beta(), Lorene::Map_et::get_beta(), get_ent(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), get_press(), Lorene::Map_af::homothetie(), logn_auto, mass_b(), mass_g(), mp, nbar, nnn, Lorene::norme(), nzet, Lorene::Map_af::poisson(), press, relativistic, s_euler, Lorene::Tenseur::set(), Lorene::Map_af::set_alpha(), Lorene::Map_af::set_beta(), Lorene::Tenseur::set_etat_qcq(), Lorene::Tenseur::set_std_base(), shift, Lorene::sqrt(), u_euler, and unsurc2.

## espec_isco()

double Lorene::Etoile_rot::espec_isco | ( |  | ) | const

virtual inherited

Energy of a particle on the ISCO.

Definition at line 301 of file et_rot_isco.C.

References p_espec_isco, and r_isco().

## extrinsic_curvature()

void Lorene::Etoile_rot::extrinsic_curvature | ( |  | ) |

inherited

Computes `tkij` and `ak_car` from `shift` , `nnn` and `b_car` .

Definition at line 57 of file et_rot_extr_curv.C.

References ak_car, b_car, Lorene::contract(), Lorene::Cmp::get_etat(), Lorene::Tenseur::get_etat(), Lorene::Etoile::mp, Lorene::Cmp::mult_rsint(), Lorene::Etoile::nnn, nphi, Lorene::Etoile::shift, tkij, and Lorene::Cmp::va.

## f_eccentric()

double Lorene::Etoile_rot::f_eccentric | ( | double | ecc,
|  | double | periast,
|  | ostream * | ost = 0x0 ) const

virtual inherited

Computation of frequency of eccentric orbits.

Parameters

  ecc | eccentricity of the orbit
  periasrt | periastron of the orbit
  ost | output stream to give details of the computation; if set to 0x0 [default value], no details will be given.

Returns
  orbital frequency

Definition at line 78 of file et_rot_f_eccentric.C.

References Lorene::Param::add_cmp(), Lorene::Param::add_int(), Lorene::Cmp::annule(), bbb, Lorene::Cmp::dsdr(), Lorene::Etoile::mp, Lorene::Etoile::nnn, nphi, Lorene::Etoile::nzet, p_f_isco, p_r_isco, Lorene::r, Lorene::Etoile::ray_eq(), Lorene::sqrt(), Lorene::Cmp::std_base_scal(), Lorene::Cmp::va, and Lorene::Valeur::val_point().

## f_eq()

double Lorene::Etoile_rot::f_eq | ( |  | ) | const

virtual inherited

Orbital frequency at the equator.

Definition at line 319 of file et_rot_isco.C.

References p_f_eq, and r_isco().

## f_isco()

double Lorene::Etoile_rot::f_isco | ( |  | ) | const

virtual inherited

Orbital frequency at the innermost stable circular orbit (ISCO).

Definition at line 267 of file et_rot_isco.C.

References p_f_isco, and r_isco().

## fait_nphi()

void Lorene::Etoile_rot::fait_nphi | ( |  | ) |

inherited

Computes `tnphi` and `nphi` from the Cartesian components of the shift, stored in `shift` .

Definition at line 781 of file etoile_rot.C.

References Lorene::Etoile::mp, nphi, Lorene::Etoile::shift, and tnphi.

## fait_omega_field()

void Lorene::Et_rot_diff::fait_omega_field | ( | double | omeg_min,
|  | double | omeg_max,
|  | double | precis,
|  | int | nitermax )

Computes (member `omega_field` ).

The computation amounts to solving the equation

for .

Parameters

  omeg_min | [input] Lower bound of the interval for searching omega
  omeg_max | [input] Higher bound of the interval for searching omega
  precis | [input] Required precision in the determination of the zero by the secant method
  nitermax | [input] Maximum number of iterations in the secant method to compute the zero.

Definition at line 73 of file et_rot_diff_faitomeg.C.

References Lorene::Param::add_cmp(), Lorene::Param::add_etoile(), Lorene::Param::add_int(), Lorene::Cmp::annule(), Lorene::Etoile_rot::bbb, fait_prim_field(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::max(), Lorene::min(), Lorene::Etoile::mp, Lorene::Cmp::mult_rsint(), Lorene::Etoile::nnn, Lorene::Etoile_rot::nphi, Lorene::Etoile::nzet, omega_field, omega_max, omega_min, Lorene::Tbl::set(), Lorene::Cmp::std_base_scal(), and Lorene::zerosec().

## fait_prim_field()

void Lorene::Et_rot_diff::fait_prim_field | ( |  | ) |

Computes the member `prim_field` from `omga_field` .

Definition at line 199 of file et_rot_diff_faitomeg.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Etoile::mp, Lorene::Etoile::nzet, omega_field, par_frot, prim_field, primfrot, and Lorene::Tbl::set().

## fait_shift()

void Lorene::Etoile_rot::fait_shift | ( |  | ) |

inherited

Computes `shift` from `w_shift` and `khi_shift` according to Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

Definition at line 748 of file etoile_rot.C.

References Lorene::Tenseur::dec2_dzpuis(), Lorene::Tenseur::dec_dzpuis(), Lorene::Tenseur::get_etat(), khi_shift, Lorene::Etoile::shift, Lorene::skxk(), and w_shift.

## funct_omega()

double Lorene::Et_rot_diff::funct_omega | ( | double | omeg | ) | const

Evaluates , where F is the function defining the rotation profile.

This function is linked to the components of the fluid 4-velocity by

`funct_omega` calls `frot` with the parameters `par_frot` .

Parameters

  omeg | [input] value of

Returns
  value of

Definition at line 315 of file et_rot_diff.C.

References frot, and par_frot.

## get_a_car()

const Tenseur & Lorene::Etoile::get_a_car | ( |  | ) | const

inline inherited

Returns the total conformal factor .

Definition at line 733 of file etoile.h.

References a_car.

## get_ak_car()

const Tenseur & Lorene::Etoile_rot::get_ak_car | ( |  | ) | const

inline inherited

Returns the scalar .

For axisymmetric stars, this quantity is related to the derivatives of by

In particular it is related to the quantities and introduced by Eqs.~(3.7) and (3.8) of Bonazzola et al. Astron. Astrophys. 278 , 421 (1993) by

Definition at line 1799 of file etoile.h.

References ak_car.

## get_b_car()

const Tenseur & Lorene::Etoile_rot::get_b_car | ( |  | ) | const

inline inherited

Returns the square of the metric factor B.

Definition at line 1715 of file etoile.h.

References b_car.

## get_bbb()

const Tenseur & Lorene::Etoile_rot::get_bbb | ( |  | ) | const

inline inherited

Returns the metric factor B.

Definition at line 1712 of file etoile.h.

References bbb.

## get_beta_auto()

const Tenseur & Lorene::Etoile::get_beta_auto | ( |  | ) | const

inline inherited

Returns the logarithm of the part of the product AN generated principaly by the star.

Definition at line 724 of file etoile.h.

References beta_auto.

## get_d_logn_auto_div()

const Tenseur & Lorene::Etoile::get_d_logn_auto_div | ( |  | ) | const

inline inherited

Returns the gradient of `logn_auto_div`.

Definition at line 719 of file etoile.h.

References d_logn_auto_div.

## get_dzeta()

const Tenseur & Lorene::Etoile_rot::get_dzeta | ( |  | ) | const

inline inherited

Returns the Metric potential = `beta_auto`.

Definition at line 1742 of file etoile.h.

References dzeta.

## get_ener()

const Tenseur & Lorene::Etoile::get_ener | ( |  | ) | const

inline inherited

Returns the proper total energy density.

Definition at line 679 of file etoile.h.

References ener.

## get_ener_euler()

const Tenseur & Lorene::Etoile::get_ener_euler | ( |  | ) | const

inline inherited

Returns the total energy density with respect to the Eulerian observer.

Definition at line 685 of file etoile.h.

References ener_euler.

## get_ent()

const Tenseur & Lorene::Etoile::get_ent | ( |  | ) | const

inline inherited

Returns the enthalpy field.

Definition at line 673 of file etoile.h.

References ent.

## get_eos()

const Eos & Lorene::Etoile::get_eos | ( |  | ) | const

inline inherited

Returns the equation of state.

Definition at line 670 of file etoile.h.

References eos.

## get_gam_euler()

const Tenseur & Lorene::Etoile::get_gam_euler | ( |  | ) | const

inline inherited

Returns the Lorentz factor between the fluid and Eulerian observers.

Definition at line 691 of file etoile.h.

References gam_euler.

## get_khi_shift()

const Tenseur & Lorene::Etoile_rot::get_khi_shift | ( |  | ) | const

inline inherited

Returns the scalar used in the decomposition of `shift`
following Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

NB: `w_shift` contains the components of with respect to the Cartesian triad associated with the mapping `mp` .

Definition at line 1773 of file etoile.h.

References khi_shift.

## get_logn()

const Tenseur & Lorene::Etoile_rot::get_logn | ( |  | ) | const

inline inherited

Returns the metric potential = `logn_auto`.

Definition at line 1729 of file etoile.h.

References logn.

## get_logn_auto()

const Tenseur & Lorene::Etoile::get_logn_auto | ( |  | ) | const

inline inherited

Returns the logarithm of the part of the lapse N generated principaly by the star.

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 701 of file etoile.h.

References logn_auto.

## get_logn_auto_div()

const Tenseur & Lorene::Etoile::get_logn_auto_div | ( |  | ) | const

inline inherited

Returns the divergent part of the logarithm of the part of the lapse N generated principaly by the star.

In the Newtonian case, this is the diverging part of the Newtonian gravitational potential (in units of ).

Definition at line 715 of file etoile.h.

References logn_auto_div.

## get_logn_auto_regu()

const Tenseur & Lorene::Etoile::get_logn_auto_regu | ( |  | ) | const

inline inherited

Returns the regular part of the logarithm of the part of the lapse N generated principaly by the star.

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 708 of file etoile.h.

References logn_auto_regu.

## get_mp()

const Map & Lorene::Etoile::get_mp | ( |  | ) | const

inline inherited

Returns the mapping.

Definition at line 659 of file etoile.h.

References Lorene::Map(), and mp.

## get_nbar()

const Tenseur & Lorene::Etoile::get_nbar | ( |  | ) | const

inline inherited

Returns the proper baryon density.

Definition at line 676 of file etoile.h.

References nbar.

## get_nnn()

const Tenseur & Lorene::Etoile::get_nnn | ( |  | ) | const

inline inherited

Returns the total lapse function N.

Definition at line 727 of file etoile.h.

References nnn.

## get_nphi()

const Tenseur & Lorene::Etoile_rot::get_nphi | ( |  | ) | const

inline inherited

Returns the metric coefficient .

Definition at line 1718 of file etoile.h.

References nphi.

## get_nuf()

const Tenseur & Lorene::Etoile_rot::get_nuf | ( |  | ) | const

inline inherited

Returns the part of the Metric potential = `logn` generated by the matter terms.

Definition at line 1734 of file etoile.h.

References nuf.

## get_nuq()

const Tenseur & Lorene::Etoile_rot::get_nuq | ( |  | ) | const

inline inherited

Returns the Part of the Metric potential = `logn` generated by the quadratic terms.

Definition at line 1739 of file etoile.h.

References nuq.

## get_nzet()

int Lorene::Etoile::get_nzet | ( |  | ) | const

inline inherited

Returns the number of domains occupied by the star.

Definition at line 662 of file etoile.h.

References nzet.

## get_omega_c()

double Lorene::Et_rot_diff::get_omega_c | ( |  | ) | const

virtual

Returns the central value of the rotation angular velocity (``[f_unit] ).

Reimplemented from Lorene::Etoile_rot.

Definition at line 327 of file et_rot_diff.C.

References omega_field.

## get_omega_field()

const Tenseur & Lorene::Et_rot_diff::get_omega_field | ( |  | ) | const

inline

Returns the angular velocity field .

Definition at line 170 of file et_rot_diff.h.

References omega_field.

## get_press()

const Tenseur & Lorene::Etoile::get_press | ( |  | ) | const

inline inherited

Returns the fluid pressure.

Definition at line 682 of file etoile.h.

References press.

## get_s_euler()

const Tenseur & Lorene::Etoile::get_s_euler | ( |  | ) | const

inline inherited

Returns the trace of the stress tensor in the Eulerian frame.

Definition at line 688 of file etoile.h.

References s_euler.

## get_shift()

const Tenseur & Lorene::Etoile::get_shift | ( |  | ) | const

inline inherited

Returns the total shift vector .

Definition at line 730 of file etoile.h.

References shift.

## get_tggg()

const Tenseur & Lorene::Etoile_rot::get_tggg | ( |  | ) | const

inline inherited

Returns the Metric potential .

Definition at line 1745 of file etoile.h.

References tggg.

## get_tkij()

const Tenseur_sym & Lorene::Etoile_rot::get_tkij | ( |  | ) | const

inline inherited

Returns the tensor related to the extrinsic curvature tensor by .

`tkij` contains the Cartesian components of .

Definition at line 1780 of file etoile.h.

References tkij.

## get_tnphi()

const Tenseur & Lorene::Etoile_rot::get_tnphi | ( |  | ) | const

inline inherited

Returns the component of the shift vector.

Definition at line 1723 of file etoile.h.

References tnphi.

## get_u_euler()

const Tenseur & Lorene::Etoile::get_u_euler | ( |  | ) | const

inline inherited

Returns the fluid 3-velocity with respect to the Eulerian observer.

Definition at line 694 of file etoile.h.

References u_euler.

## get_uuu()

const Tenseur & Lorene::Etoile_rot::get_uuu | ( |  | ) | const

inline inherited

Returns the norm of `u_euler`.

Definition at line 1726 of file etoile.h.

References uuu.

## get_w_shift()

const Tenseur & Lorene::Etoile_rot::get_w_shift | ( |  | ) | const

inline inherited

Returns the vector used in the decomposition of `shift` , following Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

NB: `w_shift` contains the components of with respect to the Cartesian triad associated with the mapping `mp` .

Definition at line 1759 of file etoile.h.

References w_shift.

## grv2()

double Lorene::Etoile_rot::grv2 | ( |  | ) | const

virtual inherited

Error on the virial identity GRV2.

This indicator is only valid for relativistic computations.

Reimplemented in Lorene::Et_magnetisation, Lorene::Et_rot_bifluid, and Lorene::Et_rot_mag.

Definition at line 254 of file et_rot_global.C.

References Lorene::Etoile::a_car, ak_car, Lorene::Etoile::ener_euler, Lorene::flat_scalar_prod(), lambda_grv2(), logn, Lorene::Etoile::mp, Lorene::Etoile::nbar, p_grv2, Lorene::Etoile::press, Lorene::Etoile::relativistic, and uuu.

## grv3()

double Lorene::Etoile_rot::grv3 | ( | ostream * | ost = 0x0 | ) | const

virtual inherited

Error on the virial identity GRV3.

The error is computed as the integral defined by Eq. (43) of [Gourgoulhon and Bonazzola, Class. Quantum Grav. 11, 443 (1994)] divided by the integral of the matter terms.

Parameters

  ost | output stream to give details of the computation; if set to 0x0 [default value], no details will be given.

Reimplemented in Lorene::Et_magnetisation, Lorene::Et_rot_bifluid, and Lorene::Et_rot_mag.

Definition at line 285 of file et_rot_global.C.

References Lorene::Etoile::a_car, ak_car, bbb, Lorene::Cmp::dsdr(), dzeta, Lorene::flat_scalar_prod(), Lorene::Cmp::get_dzpuis(), Lorene::Cmp::get_etat(), Lorene::Tenseur::gradient_spher(), Lorene::log(), logn, Lorene::Etoile::mp, Lorene::Valeur::mult_ct(), Lorene::Etoile::nbar, p_grv3, Lorene::Etoile::press, Lorene::Etoile::relativistic, Lorene::Etoile::s_euler, Lorene::Cmp::set_dzpuis(), Lorene::Tenseur::set_std_base(), Lorene::Cmp::srdsdt(), Lorene::Valeur::ssint(), Lorene::Cmp::std_base_scal(), Lorene::Valeur::sx(), uuu, Lorene::Cmp::va, and Lorene::Map_radial::xsr.

## hydro_euler()

void Lorene::Et_rot_diff::hydro_euler | ( |  | ) |

virtual

Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame.

The calculation is performed starting from the quantities `omega_field` , `ent` , `ener` , `press` , and `a_car` ,
which are supposed to be up to date.
From these, the following fields are updated: `gam_euler` , `u_euler` , `ener_euler` , `s_euler` .

Reimplemented from Lorene::Etoile_rot.

Definition at line 61 of file et_rot_diff_hydro.C.

References Lorene::Etoile::a_car, Lorene::abs(), Lorene::Cmp::annule(), Lorene::Etoile_rot::b_car, Lorene::Mtbl_cf::base, Lorene::Valeur::c_cf, Lorene::Tenseur::change_triad(), Lorene::Valeur::coef(), Lorene::Etoile_rot::del_deriv(), Lorene::Etoile::ener, Lorene::Etoile::ener_euler, Lorene::Etoile::gam_euler, Lorene::Valeur::get_etat(), Lorene::max(), Lorene::Etoile::mp, Lorene::Cmp::mult_rsint(), Lorene::Etoile::nnn, Lorene::Etoile_rot::nphi, omega_field, Lorene::Etoile::press, Lorene::Etoile::s_euler, Lorene::Tenseur::set(), Lorene::Valeur::set_etat_cf_qcq(), Lorene::Tenseur::set_etat_qcq(), Lorene::Tenseur::set_triad(), Lorene::Etoile::shift, Lorene::sqrt(), Lorene::Cmp::std_base_scal(), Lorene::Etoile::u_euler, Lorene::Etoile::unsurc2, Lorene::Etoile_rot::uuu, Lorene::Cmp::va, Lorene::x, and Lorene::y.

## is_relativistic()

bool Lorene::Etoile::is_relativistic | ( |  | ) | const

inline inherited

Returns `true` for a relativistic star, `false` for a Newtonian one.

Definition at line 667 of file etoile.h.

References relativistic.

## l_surf()

const Itbl & Lorene::Etoile_rot::l_surf | ( |  | ) | const

virtual inherited

Description of the stellar surface: returns a 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .

The stellar surface is defined as the location where the enthalpy (member `ent` ) vanishes.

Reimplemented from Lorene::Etoile.

Reimplemented in Lorene::Et_rot_bifluid.

Definition at line 95 of file et_rot_global.C.

References Lorene::Etoile::ent, Lorene::Etoile::mp, Lorene::Etoile::nzet, Lorene::Etoile::p_l_surf, and Lorene::Etoile::p_xi_surf.

## lambda_grv2()

double Lorene::Etoile_rot::lambda_grv2 | ( | const Cmp & | sou_m,
|  | const Cmp & | sou_q )

static inherited

Computes the coefficient which ensures that the GRV2 virial identity is satisfied.

is the coefficient by which one must multiply the quadratic source term of the 2-D Poisson equation

in order that the total source does not contain any monopolar term, i.e. in order that

where . is computed according to the formula

Then, by construction, the new source has a vanishing monopolar term.

Parameters

  sou_m | [input] matter source term
  sou_q | [input] quadratic source term

Returns
  value of

Definition at line 79 of file et_rot_lambda_grv2.C.

References Lorene::Valeur::c, Lorene::Cmp::check_dzpuis(), Lorene::Valeur::coef_i(), Lorene::Map_radial::dxdr, Lorene::Map_af::get_alpha(), Lorene::Map_af::get_beta(), Lorene::Cmp::get_etat(), Lorene::Tbl::get_etat(), Lorene::Valeur::get_etat(), Lorene::Mg3d::get_grille3d(), Lorene::Cmp::get_mp(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Mg3d::get_type_r(), Lorene::Map_af::set_alpha(), Lorene::Map_af::set_beta(), Lorene::Mtbl::t, Lorene::Tbl::t, Lorene::Cmp::va, Lorene::Grille3d::x, and Lorene::Map_radial::xsr.

## lspec_isco()

double Lorene::Etoile_rot::lspec_isco | ( |  | ) | const

virtual inherited

Angular momentum of a particle on the ISCO.

Definition at line 284 of file et_rot_isco.C.

References p_lspec_isco, and r_isco().

## mass_b()

double Lorene::Etoile_rot::mass_b | ( |  | ) | const

virtual inherited

Baryon mass.

Reimplemented from Lorene::Etoile.

Reimplemented in Lorene::Et_rot_bifluid.

Definition at line 125 of file et_rot_global.C.

References Lorene::Etoile::a_car, bbb, Lorene::Etoile::gam_euler, Lorene::Cmp::integrale(), Lorene::integrale(), Lorene::Etoile::nbar, Lorene::Etoile::p_mass_b, Lorene::Etoile::relativistic, and Lorene::Cmp::std_base_scal().

## mass_g()

double Lorene::Etoile_rot::mass_g | ( |  | ) | const

virtual inherited

Gravitational mass.

Reimplemented from Lorene::Etoile.

Reimplemented in Lorene::Et_magnetisation, Lorene::Et_rot_bifluid, and Lorene::Et_rot_mag.

Definition at line 157 of file et_rot_global.C.

References Lorene::Etoile::a_car, bbb, Lorene::Etoile::ener_euler, Lorene::integrale(), mass_b(), Lorene::Etoile::nnn, Lorene::Etoile::p_mass_g, Lorene::Etoile::press, Lorene::Etoile::relativistic, Lorene::Etoile::s_euler, Lorene::Tenseur::set_std_base(), tnphi, and uuu.

## mean_radius()

double Lorene::Etoile_rot::mean_radius | ( |  | ) | const

virtual inherited

Mean radius.

Definition at line 472 of file et_rot_global.C.

References area(), and Lorene::sqrt().

## mom_quad()

double Lorene::Etoile_rot::mom_quad | ( |  | ) | const

virtual inherited

Quadrupole moment.

The quadrupole moment Q is defined according to Eq. (11) of [Pappas and Apostolatos, Physical Review Letters 108, 231104 (2012)]. This is a corrected version of the quadrupole moment defined by [Salgado, Bonazzola, Gourgoulhon and Haensel, Astron. Astrophys. 291 , 155 (1994)]. Following this definition, , where is defined as the negative of the (wrong) quadrupole moment defined in Eq. (7) of [Salgado, Bonazzola, Gourgoulhon and Haensel, Astron. Astrophys. 291 , 155 (1994)], b is defined by Eq. (3.37) of [Friedman and Stergioulas, Rotating Relativistic Stars, Cambridge Monograph on mathematical physics] and M is the gravitational mass of the star.

Reimplemented in Lorene::Et_rot_bifluid.

Definition at line 600 of file et_rot_global.C.

References mass_g(), mom_quad_Bo(), mom_quad_old(), p_mom_quad, Lorene::pow(), and Lorene::Etoile::relativistic.

## mom_quad_Bo()

double Lorene::Etoile_rot::mom_quad_Bo | ( |  | ) | const

virtual inherited

Part of the quadrupole moment.

is defined as , where b is given by Eq. (3.37) of [Friedman and Stergioulas, Rotating Relativistic Stars, Cambridge Monograph on mathematical physics] and M is the the gravitational mass of the star.

Reimplemented in Lorene::Et_magnetisation, and Lorene::Et_rot_bifluid.

Definition at line 618 of file et_rot_global.C.

References Lorene::Etoile::a_car, bbb, Lorene::Cmp::integrale(), Lorene::Etoile::mp, Lorene::Cmp::mult_rsint(), Lorene::Etoile::nnn, p_mom_quad_Bo, Lorene::Etoile::press, and Lorene::Cmp::std_base_scal().

## mom_quad_old()

double Lorene::Etoile_rot::mom_quad_old | ( |  | ) | const

virtual inherited

Part of the quadrupole moment.

This term is defined by Laarakkers and Poisson, Astrophys. J. 512 , 282 (1999). Note that is the negative of the (wrong) quadrupole moment defined in Eq. (7) of [Salgado, Bonazzola, Gourgoulhon and Haensel, Astron. Astrophys. 291 , 155 (1994)].

Reimplemented in Lorene::Et_magnetisation, Lorene::Et_rot_bifluid, and Lorene::Et_rot_mag.

Definition at line 641 of file et_rot_global.C.

References Lorene::Etoile::a_car, ak_car, bbb, Lorene::Cmp::check_dzpuis(), Lorene::Etoile::ener_euler, Lorene::flat_scalar_prod(), Lorene::Cmp::get_etat(), Lorene::Tenseur::gradient_spher(), Lorene::Cmp::inc2_dzpuis(), Lorene::integrale(), Lorene::log(), logn, Lorene::Etoile::mp, Lorene::Valeur::mult_ct(), Lorene::Cmp::mult_r(), Lorene::Etoile::nbar, p_mom_quad_old, Lorene::Etoile::relativistic, Lorene::Etoile::s_euler, Lorene::Tenseur::set(), Lorene::Tenseur::set_std_base(), and Lorene::Cmp::va.

## operator=()

void Lorene::Et_rot_diff::operator= | ( | const Et_rot_diff & | et | ) |

Assignment to another `Et_rot_diff`.

Definition at line 156 of file et_rot_diff.C.

References Et_rot_diff(), frot, omega_field, omega_max, omega_min, Lorene::Etoile_rot::operator=(), par_frot, prim_field, and primfrot.

## operator>>()

ostream & Lorene::Et_rot_diff::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >> (virtual function called by the operator <<).

Reimplemented from Lorene::Etoile_rot.

Definition at line 196 of file et_rot_diff.C.

References Lorene::Etoile_rot::angu_mom(), Lorene::Etoile_rot::aplat(), display_poly(), Lorene::Etoile::ener, get_omega_c(), Lorene::Etoile_rot::mass_b(), Lorene::Etoile_rot::mass_g(), Lorene::max(), Lorene::Etoile::mp, Lorene::Etoile::nbar, Lorene::Etoile::nzet, omega_field, omega_max, omega_min, Lorene::Etoile_rot::operator>>(), par_frot, Lorene::pow(), Lorene::Etoile::press, Lorene::Etoile::ray_eq(), Lorene::sqrt(), and tsw().

## partial_display()

void Lorene::Etoile_rot::partial_display | ( | ostream & | ost | ) | const

protected virtual inherited

Printing of some informations, excluding all global quantities.

Reimplemented in Lorene::Et_rot_bifluid.

Definition at line 630 of file etoile_rot.C.

References Lorene::Etoile::a_car, aplat(), b_car, dzeta, Lorene::Etoile::ener, Lorene::Etoile::ent, get_omega_c(), logn, Lorene::Etoile::mp, Lorene::Etoile::nbar, Lorene::Etoile::nnn, nphi, Lorene::Etoile::nzet, Lorene::Etoile::press, Lorene::Etoile::ray_eq(), and uuu.

## prim_funct_omega()

double Lorene::Et_rot_diff::prim_funct_omega | ( | double | omeg | ) | const

Evaluates the primitive of , where F is the function defining the rotation profile.

Parameters

  omeg | [input] value of

Returns
  value of

Definition at line 321 of file et_rot_diff.C.

References par_frot, and primfrot.

## r_circ()

double Lorene::Etoile_rot::r_circ | ( |  | ) | const

virtual inherited

Circumferential radius.

Definition at line 390 of file et_rot_global.C.

References bbb, Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_t(), Lorene::Etoile::mp, Lorene::Etoile::nzet, p_r_circ, and Lorene::Etoile::ray_eq().

## r_isco()

double Lorene::Etoile_rot::r_isco | ( | ostream * | ost = 0x0 | ) | const

virtual inherited

Circumferential radius of the innermost stable circular orbit (ISCO).

Parameters

  ost | output stream to give details of the computation; if set to 0x0 [default value], no details will be given.

Definition at line 84 of file et_rot_isco.C.

References Lorene::Param::add_cmp(), Lorene::Param::add_int(), Lorene::Cmp::annule(), bbb, Lorene::Cmp::dsdr(), Lorene::Etoile::mp, Lorene::Etoile::nnn, nphi, Lorene::Etoile::nzet, p_espec_isco, p_f_eq, p_f_isco, p_lspec_isco, p_r_isco, Lorene::r, Lorene::Etoile::ray_eq(), Lorene::sqrt(), Lorene::Cmp::std_base_scal(), Lorene::Cmp::va, Lorene::Valeur::val_point(), and Lorene::zerosec().

## ray_eq() [1/2]

double Lorene::Etoile::ray_eq | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 120 of file etoile_global.C.

References Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq, Lorene::phi, and xi_surf().

## ray_eq() [2/2]

double Lorene::Etoile::ray_eq | ( | int | kk | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 440 of file etoile_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, Lorene::phi, and xi_surf().

## ray_eq_3pis2()

double Lorene::Etoile::ray_eq_3pis2 | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 335 of file etoile_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_3pis2, Lorene::phi, ray_eq_pis2(), and xi_surf().

## ray_eq_pi()

double Lorene::Etoile::ray_eq_pi | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 256 of file etoile_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_pi, Lorene::phi, ray_eq(), and xi_surf().

## ray_eq_pis2()

double Lorene::Etoile::ray_eq_pis2 | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 169 of file etoile_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_pis2, Lorene::phi, and xi_surf().

## ray_pole()

double Lorene::Etoile::ray_pole | ( |  | ) | const

inherited

Coordinate radius at [r_unit].

Definition at line 415 of file etoile_global.C.

References Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_pole, Lorene::phi, and xi_surf().

## sauve()

void Lorene::Et_rot_diff::sauve | ( | FILE * | fich | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Etoile_rot.

Definition at line 179 of file et_rot_diff.C.

References Lorene::fwrite_be(), omega_field, omega_max, omega_min, par_frot, and Lorene::Etoile_rot::sauve().

## set_der_0x0()

void Lorene::Etoile_rot::set_der_0x0 | ( |  | ) | const

protected virtual inherited

Sets to `0x0` all the pointers on derived quantities.

Reimplemented from Lorene::Etoile.

Reimplemented in Lorene::Et_rot_bifluid, and Lorene::Et_rot_mag.

Definition at line 364 of file etoile_rot.C.

References p_angu_mom, p_aplat, p_area, p_espec_isco, p_f_eq, p_f_isco, p_grv2, p_grv3, p_lspec_isco, p_mom_quad, p_mom_quad_Bo, p_mom_quad_old, p_r_circ, p_r_isco, p_tsw, p_z_eqb, p_z_eqf, p_z_pole, and Lorene::Etoile::set_der_0x0().

## set_enthalpy()

void Lorene::Etoile::set_enthalpy | ( | const Cmp & | ent_i | ) |

inherited

Assignment of the enthalpy field.

Definition at line 465 of file etoile.C.

References del_deriv(), ent, and equation_of_state().

## set_mp()

Map & Lorene::Etoile::set_mp | ( |  | ) |

inline inherited

Read/write of the mapping.

Definition at line 601 of file etoile.h.

References Lorene::Map(), and mp.

## tsw()

double Lorene::Et_rot_diff::tsw | ( |  | ) | const

virtual

Ratio T/W.

Reimplemented from Lorene::Etoile_rot.

Definition at line 67 of file et_rot_diff_global.C.

References Lorene::Etoile::a_car, Lorene::Etoile_rot::b_car, Lorene::Etoile_rot::bbb, Lorene::Etoile::ener, Lorene::Etoile::ener_euler, Lorene::Etoile::gam_euler, Lorene::Cmp::integrale(), Lorene::Etoile_rot::logn, Lorene::Etoile_rot::mass_g(), Lorene::Cmp::mult_r(), Lorene::Etoile::nbar, omega_field, Lorene::Etoile_rot::p_tsw, Lorene::Etoile::press, Lorene::Etoile::relativistic, Lorene::Cmp::std_base_scal(), Lorene::Etoile_rot::uuu, and Lorene::Cmp::va.

## update_metric()

void Lorene::Etoile_rot::update_metric | ( |  | ) |

inherited

Computes metric coefficients from known potentials.

The calculation is performed starting from the quantities `logn` , `dzeta` , `tggg` and `shift` , which are supposed to be up to date.
From these, the following fields are updated: `nnn` , `a_car` , `bbb` and `b_car` .

Definition at line 69 of file et_rot_upmetr.C.

References Lorene::Etoile::a_car, b_car, bbb, del_deriv(), Lorene::Cmp::div_rsint(), dzeta, Lorene::exp(), extrinsic_curvature(), logn, Lorene::Etoile::nnn, tggg, and Lorene::Etoile::unsurc2.

## xi_surf()

const Tbl & Lorene::Etoile::xi_surf | ( |  | ) | const

inherited

Description of the stellar surface: returns a 2-D `Tbl`
containing the values of the radial coordinate on the surface at the collocation points in .

The stellar surface is defined as the location where the enthalpy (member `ent` ) vanishes.

Definition at line 101 of file etoile_global.C.

References l_surf(), p_l_surf, and p_xi_surf.

## z_eqb()

double Lorene::Etoile_rot::z_eqb | ( |  | ) | const

virtual inherited

Backward redshift factor at equator.

Definition at line 545 of file et_rot_global.C.

References Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_t(), Lorene::Etoile::mp, Lorene::Etoile::nnn, nphi, Lorene::Etoile::nzet, p_z_eqb, r_circ(), Lorene::sqrt(), and uuu.

## z_eqf()

double Lorene::Etoile_rot::z_eqf | ( |  | ) | const

virtual inherited

Forward redshift factor at equator.

Definition at line 513 of file et_rot_global.C.

References Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_t(), Lorene::Etoile::mp, Lorene::Etoile::nnn, nphi, Lorene::Etoile::nzet, p_z_eqf, r_circ(), Lorene::sqrt(), and uuu.

## z_pole()

double Lorene::Etoile_rot::z_pole | ( |  | ) | const

virtual inherited

Redshift factor at North pole.

Definition at line 580 of file et_rot_global.C.

References Lorene::Etoile::nnn, p_z_pole, and Lorene::Etoile::ray_pole().

## Member Data Documentation

## a_car

Tenseur Lorene::Etoile::a_car

protected inherited

Total conformal factor .

Definition at line 515 of file etoile.h.

## ak_car

Tenseur Lorene::Etoile_rot::ak_car

protected inherited

Scalar .

For axisymmetric stars, this quantity is related to the derivatives of by

In particular it is related to the quantities and introduced by Eqs.~(3.7) and (3.8) of Bonazzola et al. Astron. Astrophys. 278 , 421 (1993) by

Definition at line 1586 of file etoile.h.

## b_car

Tenseur Lorene::Etoile_rot::b_car

protected inherited

Square of the metric factor B.

Definition at line 1507 of file etoile.h.

## bbb

Tenseur Lorene::Etoile_rot::bbb

protected inherited

Metric factor B.

Definition at line 1504 of file etoile.h.

## beta_auto

Tenseur Lorene::Etoile::beta_auto

protected inherited

Logarithm of the part of the product AN generated principaly by by the star.

Definition at line 506 of file etoile.h.

## d_logn_auto_div

Tenseur Lorene::Etoile::d_logn_auto_div

protected inherited

Gradient of `logn_auto_div` (if `k_div!=0` ).

Definition at line 501 of file etoile.h.

## dzeta

Tenseur& Lorene::Etoile_rot::dzeta

protected inherited

Metric potential = `beta_auto`.

Definition at line 1534 of file etoile.h.

## ener

Tenseur Lorene::Etoile::ener

protected inherited

Total energy density in the fluid frame.

Definition at line 460 of file etoile.h.

## ener_euler

Tenseur Lorene::Etoile::ener_euler

protected inherited

Total energy density in the Eulerian frame.

Definition at line 465 of file etoile.h.

## ent

Tenseur Lorene::Etoile::ent

protected inherited

Log-enthalpy (relativistic case) or specific enthalpy (Newtonian case).

Definition at line 457 of file etoile.h.

## eos

const Eos& Lorene::Etoile::eos

protected inherited

Equation of state of the stellar matter.

Definition at line 451 of file etoile.h.

## frot

double(* Lorene::Et_rot_diff::frot) (double, const Tbl &)

protected

Function defining the rotation profile.

This function is linked to the components of the fluid 4-velocity by

The first argument of `frot` must be ; the second argument contains the parameters, the first of which being necessarily the central value of .

Definition at line 85 of file et_rot_diff.h.

## gam_euler

Tenseur Lorene::Etoile::gam_euler

protected inherited

Lorentz factor between the fluid and Eulerian observers.

Definition at line 471 of file etoile.h.

## k_div

int Lorene::Etoile::k_div

protected inherited

Index of regularity of the gravitational potential `logn_auto` .

If `k_div=0` , `logn_auto` contains the total potential generated principaly by the star, otherwise it should be supplemented by `logn_auto_div` .

Definition at line 449 of file etoile.h.

## khi_shift

Tenseur Lorene::Etoile_rot::khi_shift

protected inherited

Scalar used in the decomposition of `shift` , following Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

Definition at line 1560 of file etoile.h.

## logn

Tenseur& Lorene::Etoile_rot::logn

protected inherited

Metric potential = `logn_auto`.

Definition at line 1521 of file etoile.h.

## logn_auto

Tenseur Lorene::Etoile::logn_auto

protected inherited

Total of the logarithm of the part of the lapse N
generated principaly by the star.

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 484 of file etoile.h.

## logn_auto_div

Tenseur Lorene::Etoile::logn_auto_div

protected inherited

Divergent part (if `k_div!=0` ) of the logarithm of the part of the lapse N
generated principaly by the star.

Definition at line 497 of file etoile.h.

## logn_auto_regu

Tenseur Lorene::Etoile::logn_auto_regu

protected inherited

Regular part of the logarithm of the part of the lapse N
generated principaly by the star.

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 491 of file etoile.h.

## mp

Map& Lorene::Etoile::mp

protected inherited

Mapping associated with the star.

Definition at line 429 of file etoile.h.

## nbar

Tenseur Lorene::Etoile::nbar

protected inherited

Baryon density in the fluid frame.

Definition at line 459 of file etoile.h.

## nnn

Tenseur Lorene::Etoile::nnn

protected inherited

Total lapse function.

Definition at line 509 of file etoile.h.

## nphi

Tenseur Lorene::Etoile_rot::nphi

protected inherited

Metric coefficient .

Definition at line 1510 of file etoile.h.

## nuf

Tenseur Lorene::Etoile_rot::nuf

protected inherited

Part of the Metric potential = `logn` generated by the matter terms.

Definition at line 1526 of file etoile.h.

## nuq

Tenseur Lorene::Etoile_rot::nuq

protected inherited

Part of the Metric potential = `logn` generated by the quadratic terms.

Definition at line 1531 of file etoile.h.

## nzet

int Lorene::Etoile::nzet

protected inherited

Number of domains of `*mp` occupied by the star.

Definition at line 432 of file etoile.h.

## omega

double Lorene::Etoile_rot::omega

protected inherited

Rotation angular velocity (``[f_unit] ).

Definition at line 1501 of file etoile.h.

## omega_field

Tenseur Lorene::Et_rot_diff::omega_field

protected

Field .

Definition at line 105 of file et_rot_diff.h.

## omega_max

double Lorene::Et_rot_diff::omega_max

protected

Maximum value of .

Definition at line 108 of file et_rot_diff.h.

## omega_min

double Lorene::Et_rot_diff::omega_min

protected

Minimum value of .

Definition at line 107 of file et_rot_diff.h.

## p_angu_mom

double* Lorene::Etoile_rot::p_angu_mom

mutable protected inherited

Angular momentum.

Definition at line 1631 of file etoile.h.

## p_aplat

double* Lorene::Etoile_rot::p_aplat

mutable protected inherited

Flatening r_pole/r_eq.

Definition at line 1637 of file etoile.h.

## p_area

double* Lorene::Etoile_rot::p_area

mutable protected inherited

Surface area.

Definition at line 1636 of file etoile.h.

## p_espec_isco

double* Lorene::Etoile_rot::p_espec_isco

mutable protected inherited

Specific energy of a particle on the ISCO.

Definition at line 1647 of file etoile.h.

## p_f_eq

double* Lorene::Etoile_rot::p_f_eq

mutable protected inherited

Orbital frequency at the equator.

Definition at line 1650 of file etoile.h.

## p_f_isco

double* Lorene::Etoile_rot::p_f_isco

mutable protected inherited

Orbital frequency of the ISCO.

Definition at line 1645 of file etoile.h.

## p_grv2

double* Lorene::Etoile_rot::p_grv2

mutable protected inherited

Error on the virial identity GRV2.

Definition at line 1633 of file etoile.h.

## p_grv3

double* Lorene::Etoile_rot::p_grv3

mutable protected inherited

Error on the virial identity GRV3.

Definition at line 1634 of file etoile.h.

## p_l_surf

Itbl* Lorene::Etoile::p_l_surf

mutable protected inherited

Description of the stellar surface: 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .

Definition at line 539 of file etoile.h.

## p_lspec_isco

double* Lorene::Etoile_rot::p_lspec_isco

mutable protected inherited

Specific angular momentum of a particle on the ISCO.

Definition at line 1649 of file etoile.h.

## p_mass_b

double* Lorene::Etoile::p_mass_b

mutable protected inherited

Baryon mass.

Definition at line 547 of file etoile.h.

## p_mass_g

double* Lorene::Etoile::p_mass_g

mutable protected inherited

Gravitational mass.

Definition at line 548 of file etoile.h.

## p_mom_quad

double* Lorene::Etoile_rot::p_mom_quad

mutable protected inherited

Quadrupole moment.

Definition at line 1641 of file etoile.h.

## p_mom_quad_Bo

double* Lorene::Etoile_rot::p_mom_quad_Bo

mutable protected inherited

Part of the quadrupole moment.

Definition at line 1643 of file etoile.h.

## p_mom_quad_old

double* Lorene::Etoile_rot::p_mom_quad_old

mutable protected inherited

Part of the quadrupole moment.

Definition at line 1642 of file etoile.h.

## p_r_circ

double* Lorene::Etoile_rot::p_r_circ

mutable protected inherited

Circumferential radius.

Definition at line 1635 of file etoile.h.

## p_r_isco

double* Lorene::Etoile_rot::p_r_isco

mutable protected inherited

Circumferential radius of the ISCO.

Definition at line 1644 of file etoile.h.

## p_ray_eq

double* Lorene::Etoile::p_ray_eq

mutable protected inherited

Coordinate radius at , .

Definition at line 521 of file etoile.h.

## p_ray_eq_3pis2

double* Lorene::Etoile::p_ray_eq_3pis2

mutable protected inherited

Coordinate radius at , .

Definition at line 530 of file etoile.h.

## p_ray_eq_pi

double* Lorene::Etoile::p_ray_eq_pi

mutable protected inherited

Coordinate radius at , .

Definition at line 527 of file etoile.h.

## p_ray_eq_pis2

double* Lorene::Etoile::p_ray_eq_pis2

mutable protected inherited

Coordinate radius at , .

Definition at line 524 of file etoile.h.

## p_ray_pole

double* Lorene::Etoile::p_ray_pole

mutable protected inherited

Coordinate radius at .

Definition at line 533 of file etoile.h.

## p_tsw

double* Lorene::Etoile_rot::p_tsw

mutable protected inherited

Ratio T/W.

Definition at line 1632 of file etoile.h.

## p_xi_surf

Tbl* Lorene::Etoile::p_xi_surf

mutable protected inherited

Description of the stellar surface: 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

Definition at line 545 of file etoile.h.

## p_z_eqb

double* Lorene::Etoile_rot::p_z_eqb

mutable protected inherited

Backward redshift factor at equator.

Definition at line 1639 of file etoile.h.

## p_z_eqf

double* Lorene::Etoile_rot::p_z_eqf

mutable protected inherited

Forward redshift factor at equator.

Definition at line 1638 of file etoile.h.

## p_z_pole

double* Lorene::Etoile_rot::p_z_pole

mutable protected inherited

Redshift factor at North pole.

Definition at line 1640 of file etoile.h.

## par_frot

Tbl Lorene::Et_rot_diff::par_frot

protected

Parameters of the function .

To be used as the second argument of functions `frot` and `primfrot` . The parameter `par_frot(0)` must always be the central angular velocity.

Definition at line 102 of file et_rot_diff.h.

## press

Tenseur Lorene::Etoile::press

protected inherited

Fluid pressure.

Definition at line 461 of file etoile.h.

## prim_field

Tenseur Lorene::Et_rot_diff::prim_field

protected

Field .

Definition at line 111 of file et_rot_diff.h.

## primfrot

double(* Lorene::Et_rot_diff::primfrot) (double, const Tbl &)

protected

Primitive of the function , which vanishes at the stellar center.

The first argument of `primfrot` must be ; the second argument contains the parameters, the first of which being necessarily the central value of .

Definition at line 93 of file et_rot_diff.h.

## relativistic

bool Lorene::Etoile::relativistic

protected inherited

Indicator of relativity: `true` for a relativistic star, `false` for a Newtonian one.

Definition at line 437 of file etoile.h.

## s_euler

Tenseur Lorene::Etoile::s_euler

protected inherited

Trace of the stress tensor in the Eulerian frame.

Definition at line 468 of file etoile.h.

## shift

Tenseur Lorene::Etoile::shift

protected inherited

Total shift vector.

Definition at line 512 of file etoile.h.

## ssjm1_dzeta

Cmp Lorene::Etoile_rot::ssjm1_dzeta

protected inherited

Effective source at the previous step for the resolution of the Poisson equation for `dzeta` .

Definition at line 1603 of file etoile.h.

## ssjm1_khi

Cmp Lorene::Etoile_rot::ssjm1_khi

protected inherited

Effective source at the previous step for the resolution of the Poisson equation for the scalar by means of `Map_et::poisson` .

is an intermediate quantity for the resolution of the elliptic equation for the shift vector

Definition at line 1616 of file etoile.h.

## ssjm1_nuf

Cmp Lorene::Etoile_rot::ssjm1_nuf

protected inherited

Effective source at the previous step for the resolution of the Poisson equation for `nuf` by means of `Map_et::poisson` .

Definition at line 1592 of file etoile.h.

## ssjm1_nuq

Cmp Lorene::Etoile_rot::ssjm1_nuq

protected inherited

Effective source at the previous step for the resolution of the Poisson equation for `nuq` by means of `Map_et::poisson` .

Definition at line 1598 of file etoile.h.

## ssjm1_tggg

Cmp Lorene::Etoile_rot::ssjm1_tggg

protected inherited

Effective source at the previous step for the resolution of the Poisson equation for `tggg` .

Definition at line 1608 of file etoile.h.

## ssjm1_wshift

Tenseur Lorene::Etoile_rot::ssjm1_wshift

protected inherited

Effective source at the previous step for the resolution of the vector Poisson equation for .

is an intermediate quantity for the resolution of the elliptic equation for the shift vector (Components with respect to the Cartesian triad associated with the mapping `mp` )

Definition at line 1625 of file etoile.h.

## tggg

Tenseur Lorene::Etoile_rot::tggg

protected inherited

Metric potential .

Definition at line 1537 of file etoile.h.

## tkij

Tenseur_sym Lorene::Etoile_rot::tkij

protected inherited

Tensor related to the extrinsic curvature tensor by .

`tkij` contains the Cartesian components of .

Definition at line 1567 of file etoile.h.

## tnphi

Tenseur Lorene::Etoile_rot::tnphi

protected inherited

Component of the shift vector.

Definition at line 1515 of file etoile.h.

## u_euler

Tenseur Lorene::Etoile::u_euler

protected inherited

Fluid 3-velocity with respect to the Eulerian observer.

Definition at line 474 of file etoile.h.

## unsurc2

double Lorene::Etoile::unsurc2

protected inherited

: `unsurc2=1` for a relativistic star, 0 for a Newtonian one.

Definition at line 442 of file etoile.h.

## uuu

Tenseur Lorene::Etoile_rot::uuu

protected inherited

Norm of `u_euler`.

Definition at line 1518 of file etoile.h.

## w_shift

Tenseur Lorene::Etoile_rot::w_shift

protected inherited

Vector used in the decomposition of `shift` , following Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

NB: `w_shift` contains the components of with respect to the Cartesian triad associated with the mapping `mp` .

Definition at line 1550 of file etoile.h.

The documentation for this class was generated from the following files:

- et_rot_diff.h
- et_rot_diff.C
- et_rot_diff_equil.C
- et_rot_diff_faitomeg.C
- et_rot_diff_global.C
- et_rot_diff_hydro.C